Imports System.ComponentModel
Imports System.Linq
Imports System.Runtime.CompilerServices
Imports Windows.Foundation
Imports Windows.Foundation.Collections
Imports Windows.Graphics.Display
Imports Windows.UI.ViewManagement
Imports Windows.UI.Xaml
Imports Windows.UI.Xaml.Controls
Imports Windows.UI.Xaml.Data
Imports System

Namespace MsdnMagazine.Fibonacci.WindowsStore.Common
    ''' <summary>
    ''' Value converter that translates true to <see cref="Visibility.Visible"/> and false to
    ''' <see cref="Visibility.Collapsed"/>.
    ''' </summary>
    Public NotInheritable Class BooleanToVisibilityConverter
        Implements IValueConverter

        Public Function Convert(ByVal value As Object, ByVal targetType As Type, ByVal parameter As Object, ByVal language As String) As Object Implements IValueConverter.Convert
            Return If(TypeOf value Is Boolean AndAlso CBool(value), Visibility.Visible, Visibility.Collapsed)
        End Function

        Public Function ConvertBack(ByVal value As Object, ByVal targetType As Type, ByVal parameter As Object, ByVal language As String) As Object Implements IValueConverter.ConvertBack
            Return TypeOf value Is Visibility AndAlso CType(value, Visibility) = Visibility.Visible
        End Function
    End Class
End Namespace
