'-----------------------------------------------------------------------
' <copyright file="IMessagingManager.vb" company="Microsoft Corporation">
'     Copyright (c) Doug Holland, Microsoft Corporation. All rights reserved.
' </copyright>
'-----------------------------------------------------------------------

Imports System.Threading.Tasks

Namespace MsdnMagazine.HelloWorld.ViewModel
	''' <summary>
	''' Provides an abstraction for platform specific user messaging capabilities.
	''' </summary>
	Public Interface IMessagingManager
		''' <summary>
		''' Displays the specified message using platform specific user messaging capabilities.
		''' </summary>
		''' <param name="message">The message to be displayed to the user.</param>
		''' <param name="title">The title of the message.</param>
		Function ShowAsync(ByVal message As String, ByVal title As String) As Task(Of MessagingResult)
		''' <summary>
		''' Displays the specified message using platform specific user messaging capabilities.
		''' </summary>
		''' <param name="message">The message to be displayed to the user.</param>
		''' <param name="title">The title of the message.</param>
		''' <param name="buttons">The buttons to be displayed.</param>
		Function ShowAsync(ByVal message As String, ByVal title As String, ByVal buttons As MessagingButtons) As Task(Of MessagingResult)
	End Interface
End Namespace
